/*
                    Sets up global garbage object

	Functions:

	void DBSetupGarbageObject()


	---

	The parameters in this special object are used to
	reset other objects back to garbage.


 */

#include "../include/objects.h"


void DBSetupGarbageObject()
{
        bzero(garbage_object.name, XSW_OBJ_NAME_MAX);
        bzero(garbage_object.empire, XSW_OBJ_PASSWORD_MAX); 
	bzero(garbage_object.password, XSW_OBJ_EMPIRE_MAX);

        garbage_object.last_updated = 0;

        garbage_object.type = XSW_OBJ_TYPE_GARBAGE;
	garbage_object.loc_type = XSW_LOC_TYPE_SPACE;
        garbage_object.imageset = ISREF_DEFAULT;
        garbage_object.owner = -1;
        garbage_object.size = 1;
        garbage_object.locked_on = -1;  
        garbage_object.intercepting_object = -1;

        garbage_object.scanner_range = 8.0;
        garbage_object.sect_x = 0;
        garbage_object.sect_y = 0;
        garbage_object.sect_z = 0;
        garbage_object.x = 0;
        garbage_object.y = 0;
        garbage_object.z = 0;
        garbage_object.heading = 0;
        garbage_object.pitch = 0;
        garbage_object.bank = 0;
        garbage_object.velocity = 0;
        garbage_object.velocity_max = 0;
        garbage_object.velocity_heading = 0;
        garbage_object.thrust_rev_state = 0;
        garbage_object.thrust_dir = 3.1415927;
        garbage_object.thrust = 0;   
        garbage_object.thrust_power = 0;   
        garbage_object.thrust_power = 0;
        garbage_object.throttle = 0;
	garbage_object.engine_state = ENGINE_STATE_ON;
        garbage_object.turnrate = 0.0003;
        garbage_object.hp = 1;
        garbage_object.hp_max = 1;
        garbage_object.power = 0;
        garbage_object.power_max = 0;
        garbage_object.power_purity = 0;
        garbage_object.core_efficency = 0;
        garbage_object.antimatter = 0;
        garbage_object.antimatter_max = 0;
        garbage_object.shield_state = SHIELD_STATE_NONE;
        garbage_object.shield_frequency = 180.25;
        garbage_object.selected_weapon = 0;
        garbage_object.total_weapons = 0;
        garbage_object.birth_time = 0;
        garbage_object.lifespan = -1;
        garbage_object.cloak_state = CLOAK_STATE_NONE;   
        garbage_object.cloak_strength = 0.0;
        garbage_object.shield_visibility = 0.0;
        garbage_object.visibility = 1.0;
	garbage_object.cur_visibility = 1.0;
        garbage_object.damage_control = DMGCTL_STATE_OFF;
	garbage_object.com_channel = COM_CHANNEL_MIN;

	garbage_object.tractored_object = NULL;
	garbage_object.total_tractored_objects = 0;

        garbage_object.permission.uid = DEFAULT_UID;
        garbage_object.permission.gid = DEFAULT_GID;

        garbage_object.animation.interval = 500;
        garbage_object.animation.last_interval = 0;
        garbage_object.animation.current_frame = 0;
        garbage_object.animation.total_frames = 1;
        garbage_object.animation.cycle_count = 0;
        garbage_object.animation.cycle_times = -1;	/* Infinatly. */

        garbage_object.weapons = NULL;
	garbage_object.score = NULL;
	garbage_object.eco = NULL;


	return;
}
