/*
	Network codes and values for communicating with the YIFF
	sound server.

 */

#ifndef YNETWORK_H
#define YNETWORK_H


/*
 *    Change mode:
 *
 *      sample_size channels sample_rate direction allow_fragmenting
 *	num_fragments fragment_size_bytes
 */
#define YNET_CMD_CHANGEMODE	"changemode"

/*
 *    Change mode preset:
 *
 *	preset_mode_name
 */
#define YNET_CMD_CHANGEMODEPRESET	"changemodepreset"

/*
 *    Cycle:
 *
 *	cycle_in_us
 */
#define YNET_CMD_CYCLE		"cycle"

/*
 *    Disconnect:
 */
#define YNET_CMD_DISCONNECT	"disconnect"

/*
 *    Host:
 *
 *	0|1 "123.123.123.123"
 */
#define YNET_CMD_HOST		"host"

/*
 *    Kill:
 *
 *	yid
 */
#define YNET_CMD_KILL		"kill"

/*
 *    Mixer:
 *
 *	mixer_code value1 value2 ... value5
 */
#define YNET_CMD_MIXER		"mixer"

/*
 *    Play:
 *
 *	yid filename pos volume_left volume_right repeats
 */
#define YNET_CMD_PLAY		"play"

/*
 *    Shutdown:
 */
#define YNET_CMD_SHUTDOWN	"shutdown"

/*
 *    Sync:
 *         
 *	cycle_ahead_us
 */
#define YNET_CMD_SYNC		"sync"

/* 
 *    System stats:
 *
 *    Output to client looks like:
 *
 *	cycle_us comp_cycle_us fragments buffer_len
 *	channels sample_size sample_rate start_time cycle_load
 */
#define YNET_CMD_SYSSTATS	"sysstats"


#endif	/* YNETWORK_H */
