#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <db.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <signal.h>

#include "../include/osw-x.h"
#include "../include/widget.h"

#include "../include/objects.h"

#include "mon.h"
#include "mesgwin.h"


/*
 *	Shutdown procedure callback.
 */
int MonShutdownPBCB(void *ptr)
{
	monitor_struct *m;
	int status;


        if(ptr == NULL)
            return(-1);

	m = (monitor_struct *)ptr;


/*   We don't know if process is on same comptuer or not,
 *   so unfortunatly we can't kill it.
 */
return(0);

	/* Send SIGTERM to server process. */
	if(m->stats.pid > 0)
	{
	    status = kill(m->stats.pid, SIGTERM);
	    if(status)
	    {
		switch(errno)
		{
		  case EINVAL:
                    fprintf(   
                        stderr,
                        "%i: Internal error, invalid signal `%i'.\n",
                        m->stats.pid, SIGTERM
                    );
		    break;

                  case ESRCH:
                    fprintf(
                        stderr, 
                        "%i: No such process.\n",
                        m->stats.pid
                    );
                    break;

		  case EPERM:
		    fprintf(
			stderr,
			"%i: Permission denied.\n",
			m->stats.pid
		    );
		    break;
		}
	    }
	}

	/* Schedual this monitor for deletion. */
	delete_monitor = m;


	return(0);
}

int MonMessagesPBCB(void *ptr)
{
        monitor_struct *m;


        if(ptr == NULL)
            return(-1);

        m = (monitor_struct *)ptr;

	MesgWinMap(&m->mesgwin);


	return(0);
}
