#include "swserv.h"


/*
 *	Shows players connected.
 */
int CmdWho(int condescriptor, char *arg)
{
	int i;
        long object_num;
        long object_con;
        int connected_players;

        char stringa[CS_DATA_MAX_LEN];
        char sndbuf[CS_DATA_MAX_LEN];
        
        
        /* Strip spaces on arg and copy to stringa. */
        strncpy(stringa, arg, CS_DATA_MAX_LEN);
        stringa[CS_DATA_MAX_LEN - 1] = '\0';
        StringStripSpaces(stringa);
        
        
        /* Print all connections? */
        if(strlen(stringa) < 1)
        {
            connected_players = 0;
            for(i = 0; i < total_connections; i++)
            {
                if(!ConIsLoggedIn(i))
                    continue;

                object_num = connection[i]->object_num;
                if(DBIsObjectGarbage(object_num))
                    continue;


                /* Format sndbuf. */
                if(connection[i]->is_guest == 0)
                {
                    sprintf(sndbuf, "%s  %i  %s",
                        DBGetFormalNameStr(object_num),
                        connection[i]->client_type,
                        StringFormatTimePeriod(
                            (long)time(NULL) -
                            (long)connection[i]->contime
                        )
                    );
                }
                else
                {
                    sprintf(sndbuf, "%s  %i  %s  Guest",
                        DBGetFormalNameStr(object_num),
                        connection[i]->client_type,
                        StringFormatTimePeriod(
                            (long)time(NULL) -
                            (long)connection[i]->contime
                        )
                    );
                }
                sndbuf[CS_DATA_MAX_LEN - 1] = '\0';
                NetSendLiveMessage(condescriptor, sndbuf);   
            
                connected_players++;
            }
  
                
            /* Print footer. */
            sprintf(sndbuf, "*** %i players connected. ***",
                    connected_players
            );
            sndbuf[CS_DATA_MAX_LEN - 1] = '\0'; 
            NetSendLiveMessage(condescriptor, sndbuf);
        }
        /* Print all connections with host names. */   
        else if(!strcmp(stringa, "*"))
        {
            connected_players = 0;
            for(i = 0; i < total_connections; i++)
            {
                if(!ConIsLoggedIn(i))
                    continue;

                object_num = connection[i]->object_num;
                if(DBIsObjectGarbage(object_num))
                    continue;


                /* Format sndbuf. */
                if(connection[i]->is_guest == 0)
                {
                    sprintf(sndbuf, "%s  %s",
                        DBGetFormalNameStr(object_num),      
                        connection[i]->conhost
                    );
                }
                else
                {
                    sprintf(sndbuf, "%s  %s  Guest",
                        DBGetFormalNameStr(object_num),
                        connection[i]->conhost
                    );
                }
                sndbuf[CS_DATA_MAX_LEN - 1] = '\0';   
                NetSendLiveMessage(condescriptor, sndbuf);
        
                connected_players++;  
            }
            /* Print footer. */
            sprintf(sndbuf,
                "*** %i players connected. ***",
                connected_players
            );
            NetSendLiveMessage(condescriptor, sndbuf);
        }        
        /* Print specific player. */
        else
        {
            object_num = MatchObjectByName(stringa, XSW_OBJ_TYPE_PLAYER);
            if(DBIsObjectGarbage(object_num))
            {               
                sprintf(sndbuf,
                    "who: %s: No such player.", 
                    stringa
                );
                NetSendLiveMessage(condescriptor, sndbuf);   
                return(-1);
            }
                 
            /* Is object_num connected? */
            for(i = 0, object_con = -1; i < total_connections; i++)
            {
                if(!ConIsLoggedIn(i))
		    continue;

                if(connection[i]->object_num == object_num)
                {
                    object_con = i;
                    break;
                }
            }
             
            /* Check if we found of a connection for the object. */
            if((object_con < 0) || (object_con >= total_connections))
            {
                sprintf(sndbuf,  
                    "who: %s: Not connected.",
                    stringa
                );
                NetSendLiveMessage(condescriptor, sndbuf);
                return(-1);
            }
        
            /* Print player. */
            if(connection[object_con]->is_guest == 0)
            {
                sprintf(sndbuf, "%s  %i  %s",   
                    DBGetFormalNameStr(object_num),
                    connection[object_con]->client_type,
                    StringFormatTimePeriod(
                        (long)time(NULL) -
                        (long)connection[object_con]->contime
                    )
                );
            }
            else
            {
                sprintf(sndbuf, "%s  %i  %s  Guest",
                    DBGetFormalNameStr(object_num),
                    connection[object_con]->client_type,
                    StringFormatTimePeriod(
                        (long)time(NULL) -
                        (long)connection[object_con]->contime
                    )
                );
            }

            sndbuf[CS_DATA_MAX_LEN - 1] = '\0';
            NetSendLiveMessage(condescriptor, sndbuf);
        }


        return(0);
}
