#include "swserv.h"



int NetHandleRefresh(int condescriptor, char *arg) 
{
	NetSendRefresh(condescriptor);

	return(0);
}


int NetSendRefresh(int condescriptor)
{
        int weapon_num;
        long object_num;
        long object_count;

        xsw_object_struct *obj_ptr;
        xsw_object_struct **tar_obj_ptr;


        /* Connection must be logged in. */
        if(!ConIsLoggedIn(condescriptor))  
            return(-1);


        /* Get object_num and obj_ptr. */
        object_num = connection[condescriptor]->object_num;
        if(DBIsObjectGarbage(object_num))
            return(-1);
        else
            obj_ptr = xsw_object[object_num];


	/* Send units. */
	NetSendUnits(condescriptor);

	/* Send data file names. */
        NetSendSetImageSet(condescriptor, unv_head.isr);
	NetSendSetSoundSet(condescriptor, unv_head.ss);
	NetSendSetOCSN(condescriptor, unv_head.ocsn);

        /* Send who am I. */
        NetSendWhoAmI(condescriptor);


        /* Send all object updates to condescriptor. */
        for(object_count = 0, tar_obj_ptr = xsw_object;
            object_count < total_objects;
            object_count++, tar_obj_ptr++
        )
        {
            /* Check objects are valid and within range. */
            if(!Mu3DInRangePtr(obj_ptr, *tar_obj_ptr,
                    obj_ptr->scanner_range)
            )
                continue;


	    /* Send create object. */
	    NetSendCreateObject(condescriptor, object_count);

            /* Send object maximums. */
            NetSendObjectMaximums(condescriptor, object_count);

            /* Send object sector position. */
            NetSendObjectName(condescriptor, object_count);

	    /* Engine state. */
	    NetSendSetEngine(condescriptor, object_count);

	    /* Com channel. */
	    NetSendSetChannel(
		condescriptor,
		object_count,
		(*tar_obj_ptr)->com_channel
	    );


            /* If locked on, send weapons and current values. */
            if(object_count == obj_ptr->locked_on)
            {
                /* Send values. */
                NetSendObjectValues(condescriptor, object_count);
        
                /* Send weapon values. */
                for(weapon_num = 0;
                    weapon_num < (*tar_obj_ptr)->total_weapons;
		    weapon_num++
                )
                {
                    NetSendWeaponValues(
                        condescriptor,   
                        object_count,
                        weapon_num
                    );
                }
            }
        }


        return(0);
}
